<script setup lang="ts">
import VoteBoxOperator from '@/components/VoteBoxOperator.vue'
import { useDataStore } from '@/store/data'
import { onMounted, reactive } from 'vue'
import API from '@/scripts/api'
import { useRouter } from 'vue-router'
import { useAppStore } from '@/store/app'
import type { VoteInformation } from '@/scripts/types'

const data = useDataStore()
const app = useAppStore()
const router = useRouter()

const state = reactive({
  search: ''
})

function searchFilter(v: VoteInformation) {
  const s = state.search.toLowerCase().trim()
  return `${v.id} ${v.title.toLowerCase().trim()}`.includes(s)
}

onMounted(refresh)
function refresh() {
  data.refreshVotes()
}

const newVoteModal = reactive({
  displayed: false,
  loading: false,
  title: ''
})

const cloneVoteModal = reactive({
  originalVote: null as VoteInformation | null,
  displayed: false,
  loading: false,
  title: ''
})

function newVote() {
  if (newVoteModal.title.length === 0) return
  newVoteModal.loading = true

  API.createNewVote(newVoteModal.title).then((vote: VoteInformation) => {
    router.push(`/votes/${vote.id}/editor`)
  }).catch(err => {
    console.error(err)
    app.notification('error', 'La création du vote a échouée')
  }).finally(() => {
    newVoteModal.loading = false
  })
}

function cloneVote(vote: VoteInformation) {
  cloneVoteModal.originalVote = vote
  cloneVoteModal.title = vote.title
  cloneVoteModal.displayed = true
}

function newClonedVote() {
  const o = cloneVoteModal.originalVote
  if (o == null) return
  API.createNewVote(cloneVoteModal.title).then((vote: VoteInformation) => {
    vote.questions = o.questions
    vote.duration = o.duration
    API.patchVote(vote.id, vote).then(() => {
      router.push(`/votes/${vote.id}/editor`)
    }).catch((err) => {
      cloneVoteModal.loading = false
      console.error(err)
      app.notification('error', 'La modification de la copie du vote a échouée')
    })
  }).catch(err => {
    console.error(err)
    app.notification('error', 'La création de la copie du vote a échouée')
    newVoteModal.loading = false
  })
}

</script>

<template>
  <div class="flex flex-col px-3 max-w-5xl mx-auto my-auto">

    <div class="flex justify-center m-6">
      <h1 class="text-2xl">
        Votes actifs
      </h1>
      <div class="flex-grow" />
      <v-text-field
        density="compact"
        variant="solo"
        label="Recherche"
        append-inner-icon="mdi-magnify"
        single-line
        hide-details
        v-model="state.search"
      />
      <v-btn variant="text" color="success" @click="() => newVoteModal.displayed = true">Créer un nouveau vote</v-btn>
      <v-btn variant="text" color="primary" @click="refresh">Actualiser</v-btn>
    </div>

    <vote-box-operator v-for="vote of data.votes.filter(e => e.status !== 'archived' && e.status !== 'canceled' && searchFilter(e))" v-bind:key="vote.id" :vote="vote" class="my-2" @clone="cloneVote(vote)"/>

    <h1 class="text-2xl m-6">
      Votes archivés
    </h1>

    <vote-box-operator v-for="vote of data.votes.filter(e => (e.status === 'archived' || e.status === 'canceled') && searchFilter(e))" v-bind:key="vote.id" :vote="vote" class="my-2" @clone="cloneVote(vote)" />
  </div>

  <v-dialog v-model="newVoteModal.displayed" max-width="500px">
    <v-card>
      <v-card-title>
        <span class="text-h5">Création d'un nouveau vote</span>
      </v-card-title>

      <v-card-text>
        <v-text-field placeholder="Titre du vote" v-model="newVoteModal.title" />
      </v-card-text>

      <v-card-actions class="justify-between">
        <v-btn variant="text" @click="() => newVoteModal.displayed = false">
          Annuler
        </v-btn>
        <v-btn :disabled="newVoteModal.title.length === 0" :loading="newVoteModal.loading" color="success" variant="text"
          @click="newVote">
          Executer
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="cloneVoteModal.displayed" max-width="500px" v-if="cloneVoteModal.originalVote != null">
    <v-card>
      <v-card-title>
        <span class="text-h5">Copie du vote #{{ cloneVoteModal.originalVote.id }}</span>
      </v-card-title>

      <v-card-text>
        <v-text-field placeholder="Titre du vote" v-model="cloneVoteModal.title" persistent-hint :hint="`Titre du vote #${cloneVoteModal.originalVote.id}: ${cloneVoteModal.originalVote.title}`" />
      </v-card-text>

      <v-card-actions class="justify-between">
        <v-btn variant="text" @click="() => cloneVoteModal.displayed = false">
          Annuler
        </v-btn>
        <v-btn :disabled="cloneVoteModal.title.length === 0 || cloneVoteModal.title === cloneVoteModal.originalVote.title"
          :loading="cloneVoteModal.loading" color="success" variant="text"
          @click="newClonedVote">
          Copier
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
